string PathWatchPath112 = "_temDM-Scripts:SetPath"

number GetPathWatchParameter112(string name)
{
TagGroup pers = GetPersistentTagGroup()
number par
TagGroupGetTagAsUInt32(pers,PathWatchPath112+":"+name,par)

return par
}

void SetPathWatchParameter112(string name, number par)
{
TagGroup pers = GetPersistentTagGroup()
TagGroupSetTagAsUInt32(pers,PathWatchPath112+":"+name,par)
}

tagGroup GetPathWatchList112(string name)
{
TagGroup pers = GetPersistentTagGroup()
TagGroup AllPath
TagGroupGetTagAsTagGroup(pers,PathWatchPath112+":"+name,AllPath)

if(!TagGroupIsValid(AllPath)) AllPath = NewTagList()

return AllPath
}

void SetPathWatchList112(string name, TagGroup AllPath)
{
TagGroup pers = GetPersistentTagGroup()
TagGroupSetTagAsTagGroup(pers,PathWatchPath112+":"+name,AllPath)

}

//This command creates dialog to choose a string from the list "AllPath" 
string selectString112(tagGroup AllPath)
	{
	//prepare dialog
    TagGroup dialog = DLGCreateDialog("")
    dialog.DLGTableLayout(1, 2, 0)
    dialog.DLGAddElement(DLGCreateLabel("Select folder:")).DLGExpand("X").DLGFill("X").DLGAnchor("West")
    TagGroup entries
    TagGroup choice = DLGCreateChoice(entries)
    dialog.DLGAddElement(choice).DLGExpand("X").DLGFill("X").DLGAnchor("West")

	number existed = TagGroupCountTags(AllPath)
    for (number i =(existed-1); i >=0;i--) 
		{
        string name
        TagGroupGetIndexedTagAsString(AllPath, i, name)
        entries.DLGAddChoiceItemEntry(name)
		}

	//open dialog
    object frame = alloc(uiframe).init(dialog)
    if (!frame.Pose()) return "null"

	//read the string based on the chosen position in the list
	number index = (existed-1) - choice.DLGGetValue()  
//result("\nindex "+index)	
	string path 
	AllPath.TagGroupGetIndexedTagAsString(index,path)
	
    return path
	}
	
	

Class watchPath112: object
{
string currentPath, newPath
taggroup AllPath
number maxPath
number taskID

	
watchPath112(object self) 
	{	
	AllPath = GetPathWatchList112("list")
	
	number ID = self.ScriptObjectGetId()
result("\nPath watcher object "+ID+" created.")
	
	maxPath = GetPathWatchParameter112("max list")
	if(maxPath ==0) maxPath = 5	//default max length of path list is 5
	
	SetPathWatchParameter112("watcher ID", ID)
	}

	
~watchPath112(object self) 
	{
	SetPathWatchParameter112("max list", maxPath)

	SetPathWatchParameter112("watcher ID", 0)

result("\nPath watcher object "+self.ScriptObjectGetId()+" destroyed.")	
	}


void SetTaskID(object self, number TaskIDP) TaskID =taskIDP

tagGroup GetAllPath(object self) return AllPath

void StopSetPath(object self) RemoveMainThreadTask(taskID)
	
	
void AddPath(object self,string path,number limit)
	{
	number Npathes = AllPath.TagGroupCountTags()
	
	//check if it is not an old path
	number existed
	string prevPath
	for(number i =0;i<Npathes;i++)
		{	        
        TagGroupGetIndexedTagAsString(AllPath, i, prevPath)

		if(prevPath==path) 
			{
			AllPath.TagGroupDeleteTagWithIndex(i)	//delete prevPath
			existed = 1
			break	
			}
		}

	//check if it exceeds the list size limit
	if(Npathes >=limit)
		{
		if(!existed) AllPath.TagGroupDeleteTagWithIndex(0)	//if(existed)  one path was already deleted
		}
		
	//insert new path at top of list	
	AllPath.TagGroupInsertTagAsString( infinity(),path)	
	
	//store list in global Tags
	SetPathWatchList112("list",AllPath)
	}

	
void WatchPath(object self) 
	{
	newPath = GetApplicationDirectory("open_save",0)

	if(currentPath != newPath)
		{
//result("\ncurrent "+ currentPath " "+newPath)
		currentPath = newPath
		self.AddPath(newPath,maxPath)	
		}	
		
	}
}